package com.xjgs;

import com.xjgs.service.HisJob;
import com.xjgs.service.HisService;
import com.xjgs.util.Logger;
import org.quartz.*;
import org.quartz.impl.StdSchedulerFactory;

import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class Application1 {
    private static Logger logger = new Logger();
    static ScheduledThreadPoolExecutor scheduledThreadPoolExecutor = null;
    public static void main(String[] args) {
        try {
            Application1 application1 = new Application1();
            application1.quartzHis();//同步电子病历与护理，每5分钟同步一次
        } catch (InterruptedException e) {
            logger.log(e.toString());
        }
    }
    public void quartzHis() throws InterruptedException{
        try {
            //创建任务器：定义任务细节
            JobDetail jobDetail = JobBuilder.newJob(HisJob.class).withIdentity("job1", "group1").build();
            ScheduleBuilder scheduleBuilder = SimpleScheduleBuilder.simpleSchedule().withIntervalInSeconds(300).repeatForever();
            //定义触发器
            Trigger trigger=TriggerBuilder.newTrigger().withIdentity("simpleTrigger", "simpleTriggerGroup")
                    .withSchedule(scheduleBuilder).startNow().build();

            //将任务和触发器注册到调度器中
            SchedulerFactory sac = new StdSchedulerFactory();
            Scheduler scheduler = sac.getScheduler();

            scheduler.scheduleJob(jobDetail, trigger);
            scheduler.start();
        } catch (SchedulerException e) {
            // TODO Auto-generated catch block
            logger.log(e.toString());
        }
    }
}
